#define _POSIX_SOURCE

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/shm.h>

struct shared_content {
    bool permission;
    char text[2048];
};

int main(){
	void *shared_memory = (void *)0;
	struct shared_content *shared_content;
	bool reading = true;

	//Vytvorenie procesu potomka pre program shm2.c:
	if(fork()==0){
		//Priradenie programu shm2.c pre proces potomka:
		[1......]("u1_2",(char *[]){NULL}, (char *[]){NULL});
		exit(0);
	}

	//Vytvorenie zdieľanej pamäte:
	int shm_id = [2......](1234,sizeof(struct shared_content),0666 | [3.........]);
	//V prípade chyby:
	if(shm_id==-1){
		exit(1);
	}

	//Pripojenie zdieľanej pamäte:
	shared_memory = [4.....](shm_id, (void *)0, 0);
	if(shared_memory == (void *)-1) {
		//V prípade chyby:
		exit(1);
	}
	
	//printf("Smernik na prvy bajt zdielanej pamate: %X.\n", (int)shared_memory);

	shared_content = (struct shared_content*) shared_memory;
	shared_content->permission = false;

	while(reading){
		if(shared_content->permission==true){
			printf("Zapisal si: %s", shared_content->text);
			sleep(rand() % 4);
			shared_content->permission = false;//Povolenie zápisu pre u1_2
			if(strncmp(shared_content->text, "end", 3) == 0) {
				reading = false;//Ak používateľ zadá reťazec "end" tak sa ukončí vykonávanie a zdieľaná pamäť sa odpojí a odstráni.      
			}
		}
	}

	//Odpojenie zdieľanej pamäte:
	if([5.....](shared_memory) == -1) {
		//V prípade chyby:
		exit(1);
	}
	else{
		printf("Zdielana pamat bola odpojena.\n");
	}

	//Odstránenie zdieľanej pamäte:
	if([6......](shm_id, [7........], 0) == -1){
		//V prípade chyby:
		exit(1);
	}

	printf("Zdielana pamat s ID = %d bola odstranena.\n", shm_id);
	exit(0);
}